ALTER TABLE QUESTIONNAIRE_ANSWER_MASTER
ADD ID_HASH VARCHAR2(50 CHAR);

UPDATE QUESTIONNAIRE_ANSWER_MASTER P
SET P.ID_HASH = ORA_HASH (P.ID || SYSTIMESTAMP || SYS_GUID ())
WHERE P.ID_HASH IS NULL;

UPDATE QUESTIONNAIRE_ANSWER_MASTER P
SET P.ID_HASH = (CASE WHEN LENGTH(P.ID_HASH) < 50 THEN LPAD(P.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(P.ID_HASH) END)       
WHERE LENGTH(P.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER QUEST_ANS_MASTER_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON QUESTIONNAIRE_ANSWER_MASTER
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2027, SYSDATE, '5.5', 1947, 'Quest answer trigger')
;
